import{S as to,i as oo,s as ao,e as a,k as f,w as fe,t as n,M as ro,c as r,d as o,m as d,a as l,x as de,h as i,b as c,G as e,g as h,y as pe,L as lo,q as ve,o as ge,B as me,v as no}from"../chunks/vendor-hf-doc-builder.js";import{I as xe}from"../chunks/IconCopyLink-hf-doc-builder.js";import{C as io}from"../chunks/CodeBlock-hf-doc-builder.js";function so(Tt){let u,ue,_,b,U,A,Ie,z,He,_e,p,Be,H,Ke,je,J,qe,Ge,F,Me,Re,we,P,Ue,B,ze,Je,Ee,D,ye,$,Fe,Q,Qe,Ve,be,w,O,V,S,We,W,Xe,Pe,E,C,X,N,Ye,Y,Ze,$e,v,g,Z,et,tt,ee,ot,at,te,rt,lt,nt,K,oe,it,st,ct,j,ae,ht,ft,Oe,y,L,re,x,dt,le,pt,Ce,m,q,ne,vt,gt,mt,G,ie,ut,_t,wt,T,se,Et,yt,ce,bt,Pt,Le;return A=new xe({}),D=new io({props:{code:"config = PPOConfig(\n    model_name=args.model_name,\n    log_with=`wandb`, # or `tensorboard`\n)",highlighted:'config = PPOConfig(\n    model_name=args.model_name,\n    log_with=`wandb`, # <span class="hljs-literal">or</span> `tensorboard`\n)'}}),S=new xe({}),N=new xe({}),x=new xe({}),{c(){u=a("meta"),ue=f(),_=a("h1"),b=a("a"),U=a("span"),fe(A.$$.fragment),Ie=f(),z=a("span"),He=n("Logging"),_e=f(),p=a("p"),Be=n(`As reinforcement learning algorithms are historically challenging to debug, it\u2019s important to pay careful attention to logging.
By default, the TRL `),H=a("a"),Ke=n("PPOTrainer"),je=n(" saves a lot of relevant information to "),J=a("code"),qe=n("wandb"),Ge=n(" or "),F=a("code"),Me=n("tensorboard"),Re=n("."),we=f(),P=a("p"),Ue=n("Upon initialization, pass one of these two options to the "),B=a("a"),ze=n("PPOConfig"),Je=n(":"),Ee=f(),fe(D.$$.fragment),ye=f(),$=a("p"),Fe=n("If you want to log with tensorboard, add the kwarg "),Q=a("code"),Qe=n('accelerator_kwargs={"logging_dir": PATH_TO_LOGS}'),Ve=n(" to the PPOConfig."),be=f(),w=a("h2"),O=a("a"),V=a("span"),fe(S.$$.fragment),We=f(),W=a("span"),Xe=n("PPO Logging"),Pe=f(),E=a("h3"),C=a("a"),X=a("span"),fe(N.$$.fragment),Ye=f(),Y=a("span"),Ze=n("Crucial values"),$e=n(`

During training, many values are logged, here are the most important ones:
`),v=a("ol"),g=a("li"),Z=a("code"),et=n("env/reward_mean"),tt=n(","),ee=a("code"),ot=n("env/reward_std"),at=n(", "),te=a("code"),rt=n("env/reward_dist"),lt=n(": the properties of the reward distribution from the \u201Cenvironment\u201D."),nt=f(),K=a("li"),oe=a("code"),it=n("ppo/mean_scores"),st=n(": The mean scores directly out of the reward model."),ct=f(),j=a("li"),ae=a("code"),ht=n("ppo/mean_non_score_reward"),ft=n(": The mean negated KL penalty during training (shows the delta between the reference model and the new policy over the batch in the step)"),Oe=f(),y=a("h3"),L=a("a"),re=a("span"),fe(x.$$.fragment),dt=f(),le=a("span"),pt=n("Training stability parameters:"),Ce=n(`

Here are some parameters that are useful to monitor for stability (when these diverge or collapse to 0, try tuning variables):
`),m=a("ol"),q=a("li"),ne=a("code"),vt=n("ppo/loss/value"),gt=n(": The value function loss \u2014 will spike / NaN when not going well."),mt=f(),G=a("li"),ie=a("code"),ut=n("ppo/val/clipfrac"),_t=n(": The fraction of clipped values in the value function loss. This is often from 0.3 to 0.6."),wt=f(),T=a("li"),se=a("code"),Et=n("objective/kl_coef"),yt=n(": The target coefficient with "),ce=a("code"),bt=n("AdaptiveKLController"),Pt=n(". Often increases before numerical instabilities."),this.h()},l(t){const s=ro('[data-svelte="svelte-1phssyn"]',document.head);u=r(s,"META",{name:!0,content:!0}),s.forEach(o),ue=d(t),_=r(t,"H1",{class:!0});var Te=l(_);b=r(Te,"A",{id:!0,class:!0,href:!0});var kt=l(b);U=r(kt,"SPAN",{});var At=l(U);de(A.$$.fragment,At),At.forEach(o),kt.forEach(o),Ie=d(Te),z=r(Te,"SPAN",{});var Dt=l(z);He=i(Dt,"Logging"),Dt.forEach(o),Te.forEach(o),_e=d(t),p=r(t,"P",{});var k=l(p);Be=i(k,`As reinforcement learning algorithms are historically challenging to debug, it\u2019s important to pay careful attention to logging.
By default, the TRL `),H=r(k,"A",{href:!0});var St=l(H);Ke=i(St,"PPOTrainer"),St.forEach(o),je=i(k," saves a lot of relevant information to "),J=r(k,"CODE",{});var Nt=l(J);qe=i(Nt,"wandb"),Nt.forEach(o),Ge=i(k," or "),F=r(k,"CODE",{});var xt=l(F);Me=i(xt,"tensorboard"),xt.forEach(o),Re=i(k,"."),k.forEach(o),we=d(t),P=r(t,"P",{});var ke=l(P);Ue=i(ke,"Upon initialization, pass one of these two options to the "),B=r(ke,"A",{href:!0});var It=l(B);ze=i(It,"PPOConfig"),It.forEach(o),Je=i(ke,":"),ke.forEach(o),Ee=d(t),de(D.$$.fragment,t),ye=d(t),$=r(t,"P",{});var Ae=l($);Fe=i(Ae,"If you want to log with tensorboard, add the kwarg "),Q=r(Ae,"CODE",{});var Ht=l(Q);Qe=i(Ht,'accelerator_kwargs={"logging_dir": PATH_TO_LOGS}'),Ht.forEach(o),Ve=i(Ae," to the PPOConfig."),Ae.forEach(o),be=d(t),w=r(t,"H2",{class:!0});var De=l(w);O=r(De,"A",{id:!0,class:!0,href:!0});var Bt=l(O);V=r(Bt,"SPAN",{});var Kt=l(V);de(S.$$.fragment,Kt),Kt.forEach(o),Bt.forEach(o),We=d(De),W=r(De,"SPAN",{});var jt=l(W);Xe=i(jt,"PPO Logging"),jt.forEach(o),De.forEach(o),Pe=d(t),E=r(t,"H3",{class:!0});var Se=l(E);C=r(Se,"A",{id:!0,class:!0,href:!0});var qt=l(C);X=r(qt,"SPAN",{});var Gt=l(X);de(N.$$.fragment,Gt),Gt.forEach(o),qt.forEach(o),Ye=d(Se),Y=r(Se,"SPAN",{});var Mt=l(Y);Ze=i(Mt,"Crucial values"),Mt.forEach(o),Se.forEach(o),$e=i(t,`

During training, many values are logged, here are the most important ones:
`),v=r(t,"OL",{});var M=l(v);g=r(M,"LI",{});var I=l(g);Z=r(I,"CODE",{});var Rt=l(Z);et=i(Rt,"env/reward_mean"),Rt.forEach(o),tt=i(I,","),ee=r(I,"CODE",{});var Ut=l(ee);ot=i(Ut,"env/reward_std"),Ut.forEach(o),at=i(I,", "),te=r(I,"CODE",{});var zt=l(te);rt=i(zt,"env/reward_dist"),zt.forEach(o),lt=i(I,": the properties of the reward distribution from the \u201Cenvironment\u201D."),I.forEach(o),nt=d(M),K=r(M,"LI",{});var $t=l(K);oe=r($t,"CODE",{});var Jt=l(oe);it=i(Jt,"ppo/mean_scores"),Jt.forEach(o),st=i($t,": The mean scores directly out of the reward model."),$t.forEach(o),ct=d(M),j=r(M,"LI",{});var Ot=l(j);ae=r(Ot,"CODE",{});var Ft=l(ae);ht=i(Ft,"ppo/mean_non_score_reward"),Ft.forEach(o),ft=i(Ot,": The mean negated KL penalty during training (shows the delta between the reference model and the new policy over the batch in the step)"),Ot.forEach(o),M.forEach(o),Oe=d(t),y=r(t,"H3",{class:!0});var Ne=l(y);L=r(Ne,"A",{id:!0,class:!0,href:!0});var Qt=l(L);re=r(Qt,"SPAN",{});var Vt=l(re);de(x.$$.fragment,Vt),Vt.forEach(o),Qt.forEach(o),dt=d(Ne),le=r(Ne,"SPAN",{});var Wt=l(le);pt=i(Wt,"Training stability parameters:"),Wt.forEach(o),Ne.forEach(o),Ce=i(t,`

Here are some parameters that are useful to monitor for stability (when these diverge or collapse to 0, try tuning variables):
`),m=r(t,"OL",{});var R=l(m);q=r(R,"LI",{});var Ct=l(q);ne=r(Ct,"CODE",{});var Xt=l(ne);vt=i(Xt,"ppo/loss/value"),Xt.forEach(o),gt=i(Ct,": The value function loss \u2014 will spike / NaN when not going well."),Ct.forEach(o),mt=d(R),G=r(R,"LI",{});var Lt=l(G);ie=r(Lt,"CODE",{});var Yt=l(ie);ut=i(Yt,"ppo/val/clipfrac"),Yt.forEach(o),_t=i(Lt,": The fraction of clipped values in the value function loss. This is often from 0.3 to 0.6."),Lt.forEach(o),wt=d(R),T=r(R,"LI",{});var he=l(T);se=r(he,"CODE",{});var Zt=l(se);Et=i(Zt,"objective/kl_coef"),Zt.forEach(o),yt=i(he,": The target coefficient with "),ce=r(he,"CODE",{});var eo=l(ce);bt=i(eo,"AdaptiveKLController"),eo.forEach(o),Pt=i(he,". Often increases before numerical instabilities."),he.forEach(o),R.forEach(o),this.h()},h(){c(u,"name","hf:doc:metadata"),c(u,"content",JSON.stringify(co)),c(b,"id","logging"),c(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(b,"href","#logging"),c(_,"class","relative group"),c(H,"href","/docs/trl/main/en/trainer#trl.PPOTrainer"),c(B,"href","/docs/trl/main/en/trainer#trl.PPOConfig"),c(O,"id","ppo-logging"),c(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(O,"href","#ppo-logging"),c(w,"class","relative group"),c(C,"id","crucial-values"),c(C,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(C,"href","#crucial-values"),c(E,"class","relative group"),c(L,"id","training-stability-parameters"),c(L,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(L,"href","#training-stability-parameters"),c(y,"class","relative group")},m(t,s){e(document.head,u),h(t,ue,s),h(t,_,s),e(_,b),e(b,U),pe(A,U,null),e(_,Ie),e(_,z),e(z,He),h(t,_e,s),h(t,p,s),e(p,Be),e(p,H),e(H,Ke),e(p,je),e(p,J),e(J,qe),e(p,Ge),e(p,F),e(F,Me),e(p,Re),h(t,we,s),h(t,P,s),e(P,Ue),e(P,B),e(B,ze),e(P,Je),h(t,Ee,s),pe(D,t,s),h(t,ye,s),h(t,$,s),e($,Fe),e($,Q),e(Q,Qe),e($,Ve),h(t,be,s),h(t,w,s),e(w,O),e(O,V),pe(S,V,null),e(w,We),e(w,W),e(W,Xe),h(t,Pe,s),h(t,E,s),e(E,C),e(C,X),pe(N,X,null),e(E,Ye),e(E,Y),e(Y,Ze),h(t,$e,s),h(t,v,s),e(v,g),e(g,Z),e(Z,et),e(g,tt),e(g,ee),e(ee,ot),e(g,at),e(g,te),e(te,rt),e(g,lt),e(v,nt),e(v,K),e(K,oe),e(oe,it),e(K,st),e(v,ct),e(v,j),e(j,ae),e(ae,ht),e(j,ft),h(t,Oe,s),h(t,y,s),e(y,L),e(L,re),pe(x,re,null),e(y,dt),e(y,le),e(le,pt),h(t,Ce,s),h(t,m,s),e(m,q),e(q,ne),e(ne,vt),e(q,gt),e(m,mt),e(m,G),e(G,ie),e(ie,ut),e(G,_t),e(m,wt),e(m,T),e(T,se),e(se,Et),e(T,yt),e(T,ce),e(ce,bt),e(T,Pt),Le=!0},p:lo,i(t){Le||(ve(A.$$.fragment,t),ve(D.$$.fragment,t),ve(S.$$.fragment,t),ve(N.$$.fragment,t),ve(x.$$.fragment,t),Le=!0)},o(t){ge(A.$$.fragment,t),ge(D.$$.fragment,t),ge(S.$$.fragment,t),ge(N.$$.fragment,t),ge(x.$$.fragment,t),Le=!1},d(t){o(u),t&&o(ue),t&&o(_),me(A),t&&o(_e),t&&o(p),t&&o(we),t&&o(P),t&&o(Ee),me(D,t),t&&o(ye),t&&o($),t&&o(be),t&&o(w),me(S),t&&o(Pe),t&&o(E),me(N),t&&o($e),t&&o(v),t&&o(Oe),t&&o(y),me(x),t&&o(Ce),t&&o(m)}}}const co={local:"logging",sections:[{local:"ppo-logging",sections:[{local:"crucial-values",title:"Crucial values"},{local:"training-stability-parameters",title:"Training stability parameters:"}],title:"PPO Logging"}],title:"Logging"};function ho(Tt){return no(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class go extends to{constructor(u){super();oo(this,u,ho,so,ao,{})}}export{go as default,co as metadata};
